/*Ghassan Fakher
section 6
gkf01
201301739*/

// program that neglects the cases and "" and "." and spaces .. and tells whether the given string is a palindrome or not
public class Palindromes2
{
	public static void main(String[] args)
	{
		int numStrings = Integer.parseInt(args[0]);
		for(int i = 1; i <= numStrings; i++)
		{
			if(isPalindromePhrase(args[i]))
			{
				System.out.println(args[i] + " is palindrome.");
			}
			else
			{
				System.out.println(args[i] + " is not a palindrome.");
			}
		}
	}
	public static boolean isPalindromePhrase(String str)
	{
		int length = str.length();
		boolean isPalindrome = true;
		int leftFinger = 0;		// left finger represents a selection of the characters of the string from the right
		int rightFinger = length - 1;	// right finger represents a selection of the characters of the string that are from the left 
		while(isPalindrome && leftFinger <= rightFinger)
		{
			char leftC = str.charAt(leftFinger);
			while(!Character.isLetter(leftC))
			{
				leftFinger++;
				leftC = str.charAt(leftFinger);	
			}
			char rightC = str.charAt(rightFinger);
			while(!Character.isLetter(rightC))
			{
				rightFinger--;
				rightC = str.charAt(rightFinger);				
			}
			if(compareLettersNoCases(rightC, leftC))
			{
				isPalindrome = true;
			}
			else
			{
				isPalindrome = false;
			}
			leftFinger++;
			rightFinger--;
		}
		return isPalindrome;
	}
	// method that ignores uppercases and checks whether each character is the same as the other
	public static boolean compareLettersNoCases(char rightC , char leftC)
	{
		boolean same = true;
		rightC = Character.toLowerCase(rightC);
		leftC = Character.toLowerCase(leftC);
		String s1 = "" + rightC;
		String s2 = "" + leftC;
		if(s1.charAt(0) == s2.charAt(0))
		{
			same = true;
		}
		else
		{
			same = false;
		}
		return same;
	}
}
